summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorTony Breeds <tony@bakeyournoodle.com>2016-12-21 13:27:20 +1100
committerTim Burke <tim.burke@gmail.com>2016-12-27 15:47:18 -0800
commitf2f278fcbec3ad52a1726bb5a3f775d13bcc99dc (patch)
treec2580c4261c4d730f9b91f7c4e5adc2e94b82a67
parentaea0585ddbc749b6f4d501430d41b671932c11a4 (diff)
downloadpython-swiftclient-f2f278fcbec3ad52a1726bb5a3f775d13bcc99dc.tar.gz
Add Constraints support
Adding constraints support to libraries is slightly more complex than services as the libraries themselves are listed in upper-constraints.txt which leads to errors that you can't install a specific version and a constrained version. This change adds constraints support by also adding a helper script to edit the constraints to remove python-swiftclient. Change-Id: I3947a6165eaa9f5cb62a7df4f5a2c16065da2f1d
-rw-r--r--bindep.txt1
-rwxr-xr-xtools/tox_install.sh31
-rw-r--r--tox.ini13
3 files changed, 41 insertions, 4 deletions
diff --git a/bindep.txt b/bindep.txt
index efc5441..e3ea9c1 100644
--- a/bindep.txt
+++ b/bindep.txt
@@ -1,5 +1,6 @@
# This is a cross-platform list tracking distribution packages needed by tests;
# see http://docs.openstack.org/infra/bindep/ for additional information.
+curl
pypy [test]
pypy-dev [test]
diff --git a/tools/tox_install.sh b/tools/tox_install.sh
new file mode 100755
index 0000000..15aa9de
--- /dev/null
+++ b/tools/tox_install.sh
@@ -0,0 +1,31 @@
+#!/usr/bin/env bash
+
+# Client constraint file contains this client version pin that is in conflict
+# with installing the client from source. We should remove the version pin in
+# the constraints file before applying it for from-source installation.
+
+set -e
+
+if [[ -z "$CONSTRAINTS_FILE" ]]; then
+ echo 'WARNING: expected $CONSTRAINTS_FILE to be set' >&2
+ PIP_FLAGS=(-U)
+else
+ # NOTE(tonyb): Place this in the tox enviroment's log dir so it will get
+ # published to logs.openstack.org for easy debugging.
+ localfile="$VIRTUAL_ENV/log/upper-constraints.txt"
+
+ if [[ "$CONSTRAINTS_FILE" != http* ]]; then
+ CONSTRAINTS_FILE="file://$CONSTRAINTS_FILE"
+ fi
+ curl "$CONSTRAINTS_FILE" --insecure --progress-bar --output "$localfile"
+
+ pip install -c"$localfile" openstack-requirements
+
+ # This is the main purpose of the script: Allow local installation of
+ # the current repo. It is listed in constraints file and thus any
+ # install will be constrained and we need to unconstrain it.
+ edit-constraints "$localfile" -- "$CLIENT_NAME"
+ PIP_FLAGS=(-c"$localfile" -U)
+fi
+
+pip install "${PIP_FLAGS[@]}" "$@"
diff --git a/tox.ini b/tox.ini
index e2f1265..df01bf8 100644
--- a/tox.ini
+++ b/tox.ini
@@ -1,14 +1,17 @@
[tox]
envlist = py27,py34,py35,pypy,pep8
-minversion = 1.6
+minversion = 2.0
skipsdist = True
[testenv]
usedevelop = True
-install_command = pip install -U {opts} {packages}
+install_command = {toxinidir}/tools/tox_install.sh {opts} {packages}
setenv =
LANG=en_US.utf8
VIRTUAL_ENV={envdir}
+ BRANCH_NAME=master
+ CLIENT_NAME=python-swiftclient
+ CONSTRAINTS_FILE={env:UPPER_CONSTRAINTS_FILE:https://git.openstack.org/cgit/openstack/requirements/plain/upper-constraints.txt}
deps = -r{toxinidir}/requirements.txt
-r{toxinidir}/test-requirements.txt
@@ -28,11 +31,13 @@ commands =
commands = {posargs}
[testenv:cover]
-commands = python setup.py testr --coverage
+commands = python setup.py testr --coverage
coverage report
[testenv:func]
-setenv = OS_TEST_PATH=tests.functional
+setenv =
+ {[testenv]setenv}
+ OS_TEST_PATH=tests.functional
whitelist_externals =
coverage
rm